#include "pqueue.h"
#define WQUEUE_INIT PQUEUE_INIT

/*
Definition af arbejdsfunktionen.
*/
typedef void (*work_f)(void *);

/*
ben definition af en arbejdsk instans. Denne kan
ndress efter behov, slnge det ikke ndrer p nedenstende
funktioners grnseflade.
*/
typedef struct wqueue wqueue_t;


/* ken */
wqueue_t *head;


/*
Indstter et stykke arbejde i form af en funktion 'func' og det
data 'data' den skal kaldes med. Prioriteten 'pri' angiver
arbejdets prioritet. 'wq' peger p en instans af arbejdsken.

Lykkedes indsttelsen skal funktionen returnerer '0'. Ved fejl '-1'.
*/
int wqueue_insert(wqueue_t *wq, unsigned int pri, work_f func, void *data);

/*
Udfrer et stykke arbejde fra ken.

Hvis ken er tom returneres '0', ellers '1'.
*/
void *wqueue_ts_run(void *wq);

/*
Trdsikker (thread-safe) udgave af 'wqueue_insert'.
*/
int wqueue_ts_insert(wqueue_t *wq, unsigned int pri, work_f func, void *data);

/*
Starter en trdpulje (thread pool) med 'cnt' trde. Trdene udtager arbjede
fra ken og udfrer det. Hvis der ikke er noget arbejde skal trdende blokkere
og vente p at der kommer nyt arbejde.

Nr ken er tom og alle trde er frdige med at arbejde returneres '0'. Ved fejl
returneres '-1';
*/
int wqueue_thread_pool(wqueue_t *wq, unsigned int cnt);

/* initialiser en k */
pqueue_t *init_queue();
